// This MFC Samples source code demonstrates using MFC Microsoft Office Fluent User Interface 
// (the "Fluent UI") and is provided only as referential material to supplement the 
// Microsoft Foundation Classes Reference and related electronic documentation 
// included with the MFC C++ library software.  
// License terms to copy, use or distribute the Fluent UI are available separately.  
// To learn more about our Fluent UI licensing program, please visit 
// http://go.microsoft.com/fwlink/?LinkId=238214.
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// DataGridViewAppView.cpp : implementation of the CDataGridViewAppView class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "DataGridViewApp.h"
#endif

#include "DataGridViewAppDoc.h"
#include "DataGridViewAppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDataGridViewAppView

IMPLEMENT_DYNCREATE(CDataGridViewAppView, CFormView)

BEGIN_MESSAGE_MAP(CDataGridViewAppView, CFormView)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_COMMANDS_COMPUTE, &CDataGridViewAppView::OnCommandsCompute)
END_MESSAGE_MAP()

// CDataGridViewAppView construction/destruction

CDataGridViewAppView::CDataGridViewAppView()
	: CFormView(IDD_DATAGRIDVIEWAPP_FORM)
{
	// TODO: add construction code here

}

CDataGridViewAppView::~CDataGridViewAppView()
{
}

void CDataGridViewAppView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);

	DDX_ManagedControl(pDX, IDC_SPREADSHEET, this->m_CtrlSpreadsheet);
}

BOOL CDataGridViewAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CDataGridViewAppView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	ResizeParentToFit();

}

void CDataGridViewAppView::OnRButtonUp(UINT /* nFlags */, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CDataGridViewAppView::OnContextMenu(CWnd* /* pWnd */, CPoint point)
{
#ifndef SHARED_HANDLERS
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
#endif
}


// CDataGridViewAppView diagnostics

#ifdef _DEBUG
void CDataGridViewAppView::AssertValid() const
{
	CFormView::AssertValid();
}

void CDataGridViewAppView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDataGridViewAppDoc* CDataGridViewAppView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDataGridViewAppDoc)));
	return (CDataGridViewAppDoc*)m_pDocument;
}
#endif //_DEBUG


// CDataGridViewAppView message handlers


void CDataGridViewAppView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	if (this->m_CtrlSpreadsheet.GetSafeHwnd())
	{
		CRect rect; this->GetClientRect(&rect);
		this->m_CtrlSpreadsheet.MoveWindow(&rect);
	}
}


BOOL CDataGridViewAppView::OnEraseBkgnd(CDC* pDC)
{
	// TODO: Add your message handler code here and/or call default

	//return CFormView::OnEraseBkgnd(pDC);
	return TRUE;

}

void CDataGridViewAppView::OnCommandsCompute()
{
	// TODO: Add your command handler code here
	AfxMessageBox(L"Okay, let's compute the expressions in the spreadsheet!");
}
